package index;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
sub FileName {
    local($nom)=@_;
    if ($nom =~ /([\w+_\.]+)$/) { $nom=$1; }
    return($nom);
}
#|#######################################################
sub GetIncludeCibleOfWrite { # donne le nom cible du fichier include
   if ( $_[0] =~ /^\.\.\/(.*)/ ) {
      $_[0] = $1 ;
   }
   if ( $_[0] =~ /^\.\/(.*)/ ) {
      $_[0] = $1 ;
   }
   $_[0] =~ s/\//_/g;
}
#|#######################################################
sub En_Tete_Input {
    local($file,$fic,$source)=@_;
    local($ligne)="";
    $file_bis = $fic ;
    $main::Verbatim_Style = 0;
    $enteteloc=main::En_Tete_All($file_bis,"input",$source);
# en-tete du fichier
#-------------------
    $ligne="<HTML><HEAD>
<TITLE>$fic $main::RepCodeSource</TITLE></HEAD>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H3 align=center>$fic</H3>
$enteteloc
";
    if (($source) && ("$source" eq "source")) {
	$ligne .= "<P> Liste des fichiers utilisant <A HREF=\"${fic}_i.html\" TARGET=\"index\">$file</A>.";
    } else {
	$ligne .= "<P> Liste des fichiers utilisant <A HREF=\"inpuindex_c.html#$fic\" TARGET=\"source\">$fic</A>.";
    }
    $ligne .= "<HR>\n";
    return($ligne);
} ;
#|#######################################################
sub Fortran_Input_Construct {
    local($file,$cible)=@_;
    local($ligne)="";
    if (open (INPUT, $file)){
	if (($main::appels_de_input{$file})&&($cible)) {
	    open (TARGET, ">$main::DIRE/${cible}_c.html") or die "Probleme 0" ;
	    open (LEFTINDEX, ">$main::DIRE/${cible}_i.html") or die "Probleme 0" ;
	    open (MAINFRAME, ">$main::DIRE/${cible}.html") or die "Probleme 0" ;
	    print MAINFRAME '<html>
<head>
   <title>'.$cible.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${cible}.'_i.html" NAME="index">
  <frame SRC="'.${cible}.'_c.html" NAME="source">
</frameset>
</html>' ;
            close (MAINFRAME) ;
	    local($header)="";
	    $header = En_Tete_Input($file,$cible,"source");
	    print TARGET $header ;
	    $header = En_Tete_Input($file,$cible,"index");
	    $header .= Manage_Index_Input($file,$cible,"source");
	    print LEFTINDEX $header ;
            close (LEFTINDEX) ;
	    local($normalligne)="";
	    if ($main::opt_h) {
		while (defined($LIGNEINP=<INPUT>)) {
		    $ligne .= $LIGNEINP ;
		    if ($LIGNEINP =~ /[<>]/) {
			$LIGNEINP =~ s/</&lt;/g ;
			$LIGNEINP =~ s/>/&gt;/g ;
		    }
		    $normalligne .= main::LatexBuiltinProcess($LIGNEINP);
		}
		$hevea="$main::DIRE/hevea_$cible";
		$hevea =~ s/\.\w+$//;
		local($hevealigne) = main::LatexHeveaProcess($ligne);
		&main::HeveaConstructFile($hevea,$hevealigne);
		local($target)="hevea_$cible";
		$target =~ s/\.\w+$//;
		if ($target =~ /.*\/([\w\._]+)/) {
		    local($target)=$1 ;
		}
		print TARGET "<BR><A Href=$target.html>Hevea Translation</A>\n";
		print TARGET "<BR><A Href=$ftagshtmldoc/browser.html>Correctly Configure Netscape.</A>\n<BR>";
		print TARGET "$normalligne\n";
	    } else {
		while (defined($LIGNEINP=<INPUT>)) {
		    chop($LIGNEINP);
		    $ligne .= main::LatexBuiltinProcess($LIGNEINP);
		}
		print TARGET "$ligne\n";
	    }
	    print TARGET "<HR>\n";
	    print TARGET "</BODY></HTML>\n";
	    close(TARGET);
        }
        close(INPUT);
    } else {
        print "Le fichier $input n'existe pas.\n$ligne\n";
    }
}
#|#######################################################
sub OpenIndex {
# Dfinit un titre de code d'index.
    local($titre)=@_;
    local($ligne)="";
    $ligne="<HTML>
<HEAD>
<TITLE>$titre</TITLE>
</HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
function LienDynamique(document2){
   top.index.location=document2 ;
}
</SCRIPT>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1 align=center>$titre</H1>
";
    return($ligne);
}
#|#######################################################
sub OpenMainFrame {
# Dfinit les frames de base
    local($index,$source,$titre)=@_;
    local($ligne)='<html>
<head>
   <title>'.$titre.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.$index.'.html" NAME="index">
  <frame SRC="'.$source.'.html" NAME="source">
</frameset>
</html>' ;
    return($ligne);
}
#|#######################################################
sub Index_Input {
# index des input
    open(MAINFRAME,">$main::DIRE/inpuindex.html");
    print MAINFRAME OpenMainFrame("index","inpuindex_c","Index des commentaires de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inpuindex_c.html");
    print INDEX OpenIndex("Index des commentaires de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort @main::listetex ;
    if ($ENV{FTAGSHTML_DOC}) {
	$ftagshtmldoc="$ENV{FTAGSHTML_DOC}" ;
    } else {
	$ftagshtmldoc="$ENV{FTAGSHTML_DIR}/doc" ;
    }
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des variables (numro de ligne) :</H3><OL>\n";
	while (@liste) {
	    $nom=shift @liste;
	    $cible = $nom ;
	    &GetIncludeCibleOfWrite($cible) ;
	    Fortran_Input_Construct($nom,$cible);
	    $ligne=Manage_Index_Input($nom,$cible,"source","index");
	    print INDEX "<LI>$ligne\n";
	}
    } else {
	print INDEX "<H3>Pas de variable dfinie dans un fichier spar.</H3>\n";
	print INDEX "<H3>C'est dommage, vous risquez de construire des commentaires";
	print INDEX " contradictoires sur des variables communes  plusieurs";
	print INDEX " sous-programmes.</H3>\n";
	print INDEX "<H3>De plus, cette technique permet de constituer deux";
	print INDEX " types de source: l'un comment, l'autre non.</H3><OL>\n";
    }
    &Index_Ferme;
} ;
#|#######################################################
sub OnClick {
    local($cref,$tag,$index)=@_;
    if (($index) && ("$index" ne "")) {
	if (($tag) && ("$tag" ne "")) {
	    return(" onClick=LienDynamique(\"${cref}_i.html#$tag\")");
        } else {
	    return(" onClick=LienDynamique(\"${cref}_i.html\")");
	}
    } else {
	return("");
    }
}
#|#######################################################
sub Manage_Index_Input {
# index des input
    local($nom,$cible,$source,$index)=@_;
    $index = "" unless ($index);
    local($target)="";
    if (($source) && ("$source" ne "")) {
	$target=" TARGET=\"$source\"";
    }
    $source = "" unless $source ;
    local($ligne)="";
    $ref="$nom.html#I_$nom";
    $ref="$nom#I_$nom";
#	$ref="$main::INPUTNOM/$cible.html";
    $ref="$cible";
    (@tata) = split ( /\//, $nom) ;
    (@Var) = split ( /\./, $tata[$#tata]) ;
    $Variable = $Var[0] ;
    $main::file=$nom ;
    $file_loc = FileName($nom) ;
    $ligne .= "<A NAME=$cible></A><A NAME=$file_loc></A>";
    $ligne .= "<A HREF=\"".main::CodeName($ref,"$source").".html\" ".main::Target("$source").OnClick("$ref","","$index").">$Variable</A> ";
    $ligne .= " est demand par:\n";
    @liste_appels=split(/:/, $main::appels_de_input{$nom});
    shift @liste_appels;
    $ligne .= "<UL>\n";
    while (@liste_appels) {
	$fichier=shift @liste_appels ;
	$num=shift @liste_appels ;
	$RoutEncour=shift @liste_appels ;
	$ligne .= "<LI>";
	$ligne .= "<A HREF=\"".main::CodeName($fichier,"$source").".html#R_$RoutEncour\" ".main::Target("$source").OnClick("$fichier","R_$RoutEncour","$index").">$RoutEncour</A>\n";
	$ligne .= " <A HREF=\"".main::CodeName($fichier,"$source").".html#I_$nom$num\" ".main::Target("$source").OnClick("$fichier","R_$RoutEncour","$index").">($num)</A>\n";
    }
    $ligne .= "</UL>\n";
    return($ligne);
} ;
#|#######################################################
sub Index_Fichiers {
    local(@liste)=(sort @_) ;
# index des fichiers
    open(MAINFRAME,">$main::DIRE/fileindex.html");
    print MAINFRAME OpenMainFrame("index","fileindex_c","Index des fichiers de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/fileindex_c.html");
    print INDEX OpenIndex("Index des fichiers de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    local($source,$index)=("source","index");
    foreach $file (@liste) {
	$file_ter = $main::File_Of_Rout{$file};
	if ($main::NBL{$file}) {
	    $file_ter = $main::File_Of_Rout{$file};
	    $filebis = $file ;
	    $file_loc = FileName($file) ;
	    &GetIncludeCibleOfWrite($filebis) ;
	    if ($main::fichier_to_Routine{$file}) {
		(@liste_def) = sort split(/:/, $main::fichier_to_Routine{$file}) ;
		$nb_def = $#liste_def+1 ;
		print INDEX "<P><A NAME=$filebis><LI></A><A NAME=$file_loc>";
		print INDEX "</A><A HREF=\"".main::CodeName($filebis,"$source").".html\" ".main::Target("$source").OnClick("$filebis","","$index").">$file</A>:";
		if ( $nb_def > 1 ) {
		    print INDEX " ($main::NBL{$file}) dfinit $nb_def sous-programmes:\n";
		} else {
		    print INDEX " ($main::NBL{$file}) dfinit $nb_def sous-programme:\n";
		}
		print INDEX "<UL>\n";
		foreach $Routine (@liste_def) {
		    if ( $main::L_Declar{$Routine} ) {
			print INDEX "<LI>" if ($nb_def > 1) ;
			print INDEX "<A HREF=\"".main::CodeName($filebis,"$source").".html#R_$Routine\" ".main::Target("$source").OnClick("$filebis","R_$Routine","$index").">$Routine</A> ($main::L_Declar{$Routine})\n";
		    } else {
			print INDEX "<LI>" if ($nb_def > 1) ;
			print INDEX "<A HREF=\"".main::CodeName($filebis,"$source").".html#R_$Routine\" ".main::Target("$source").OnClick("$filebis","R_$Routine","$index").">$Routine</A> (1)\n";
			print "Unexpected $filebis for $Routine\n";
		    }
		    $ligne=(main::Gere_Index_Includes($file,$Routine,"source","index")) ;
		    print INDEX "$ligne\n";
		}
		print INDEX "</UL>\n";
		if ($main::fonctions_includes{$file}) {
		    print INDEX "Le fichier <A HREF=\"".main::CodeName($filebis,"$source").".html\" ".main::Target("$source").OnClick("$filebis","","$index").">$file</A> utilise en global:\n" ;
		}
	    } else {
		print INDEX "<P><A NAME=$filebis><LI></A>";
		print INDEX "<A HREF=\"".main::CodeName($filebis,"$source").".html\" ".main::Target("$source").OnClick("$filebis","","$index").">$file</A>:";
		print INDEX " ($main::NBL{$file}) ne dfinit aucun sous-programme,";
		if ($main::fonctions_includes{$file}) {
		    print INDEX "mais utilise:\n" ;
		} else {
		    print INDEX "et n'utilise aucun fichier 'include'.\n" ;
		}
	    }
	    if ($main::fonctions_includes{$file}) {
		$ligne=(main::Gere_Index_Includes($file,$file,"$source","$index")) ;
		print INDEX "$ligne\n";
	    } elsif (0) {
		@liste_appels_complet = sort split(/ /, $main::fonctions_includes{$file});
		print INDEX "<UL>\n";
		$prev_fichier = "" ;
		while (@liste_appels_complet) {
		    @liste_appels=split(/:/, shift @liste_appels_complet);
		    shift @liste_appels;
		    local($fichier)=shift @liste_appels;
		    local($ref)=$fichier;
		    local($num)=shift @liste_appels;
		    &GetIncludeCibleOfWrite($ref) ;
		    if ($fichier_full_name=main::find_include($fichier)) {
			&GetIncludeCibleOfWrite($fichier_full_name) ;
			$ref=$fichier_full_name ;
		    }
		    if ($prev_fichier eq "") {
			print INDEX "<LI>";
			print INDEX "<A HREF=$ref.html>$fichier</A> ";
			print INDEX "(<A HREF=$filebis.html#I_$ref$num>$num</A>)";
		    }  elsif($prev_fichier eq $fichier) {
			print INDEX ", (<A HREF=$filebis.html#I_$ref$num>$num</A>)";
		    } else {
			print INDEX ",\n<LI>";
			print INDEX "<A HREF=$ref.html>$fichier</A>";
			print INDEX " (<A HREF=$filebis.html#I_$ref$num>$num</A>)";
		    }
		    $prev_fichier = $fichier ;
		}
		print INDEX ".\n</UL>\n";
	    }
	} else {
	    print INDEX "<P><I>$file</I> n'est pas utilis. ";
	    print INDEX "<A HREF=$DIRC/$file>Source original</A>\n";
	}
    }
    &Index_Ferme;
} ;
#|#######################################################
sub Index_Include {
# index des includes
    open(MAINFRAME,">$main::DIRE/inclindex.html");
    print MAINFRAME OpenMainFrame("index","inclindex_c","Index des includes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inclindex_c.html");
    print INDEX OpenIndex("Index des includes de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");

    @liste=sort @main::includes ;
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des includes (numro de ligne) :</H3>\n";
	print INDEX "<OL>\n";
	while (@liste) {
	    $nom=shift @liste;
	    $ligne = Manage_Index_Include($nom,"source","index");
#	    $ligne = main::Gere_Index_Includes($nom,$nom,"");
	    print INDEX "<LI>$ligne";
	}
	print INDEX "</OL>\n";
    } else {
	print INDEX "<H3>Pas de fichier import par 'include'</H3><OL>\n";
    }
    &Index_Ferme;
} ;
#|#######################################################
sub Manage_Index_Include {
    local($nom,$source,$index)=@_;
    $index = "" unless ($index);
    local($target)="";
    local($fileext)="";
    if (($source) && ("$source" ne "")) {
	$target=" TARGET=\"$source\"";
	$fileext="_c";
    }
    local($ligne)="";
    $file_loc = FileName($nom) ;
    $filebis = $nom ;
    &GetIncludeCibleOfWrite($filebis) ;
    if ($fichier_full_name=main::find_include($nom)) {
	&GetIncludeCibleOfWrite($fichier_full_name) ;
	$filebis=$fichier_full_name.$fileext ;
	$file_bis=$fichier_full_name;
	$ligne .= "<A NAME=$filebis></A><A NAME=$file_loc></A>";
	$ligne .= " <A HREF=\"".main::CodeName($fichier_full_name,"$source").".html\" ".main::Target("$source").OnClick("$file_bis","","$index").">$nom</A>\n";
    } else {
	$ligne .= "<A NAME=$file_loc><I><FONT COLOR=RED>$nom</FONT></I>\n" ;
    }
    $ligne .= "demand par:\n" ;
    @liste_appels=split(/:/, $main::appels_de_includes{$nom});
    shift @liste_appels;
    $ligne .= "<UL>\n";
    $prev_fichier = "" ;
    while (@liste_appels) {
	local($RoutEncour)=shift @liste_appels ;
	local($num)=shift @liste_appels ;
	local($fichier)=$main::File_Of_Rout{$RoutEncour} ;
	local($ref)=$fichier ;
	&GetIncludeCibleOfWrite($ref) ;
	if ($prev_fichier eq $RoutEncour) {
	    $ligne .= ", (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	} elsif ($prev_fichier eq "") {
	    if ( $fichier eq $RoutEncour ) {
		$ligne .= "<LI><A HREF=\"".main::CodeName($ref,"$source").".html\" ".main::Target("$source").OnClick("$ref","","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    } else {
		$ligne .= "<LI><A HREF=\"".main::CodeName($ref,"$source").".html#R_$RoutEncour\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    }
	} else {
	    if ( $fichier eq $RoutEncour ) {
		$ligne .= ".\n <LI><A HREF=\"".main::CodeName($ref,"$source").".html\" ".main::Target("$source").OnClick("$ref","","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    } else {
		$ligne .= ".\n <LI><A HREF=\"".main::CodeName($ref,"$source").".html#R_$RoutEncour\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    }
	}
	$prev_fichier = $RoutEncour ;
    }
    $ligne .= ".\n</UL>\n";
    return($ligne);
}
#|#######################################################
sub FunSubIndex {
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	print INDEX "<P><A NAME=$nom><LI></A>\n";
	print INDEX "<A HREF=\"${file}_c.html#R_$Routine\" TARGET=\"source\"".OnClick("$file","R_$Routine","index").">".$nom."</A>";
	print INDEX " est dclare dans <A HREF=\"${file}_c.html\" TARGET=\"source\"".OnClick("$file","","index").">".$file."</A> ";
	print INDEX "ligne $main::L_Declar{$nom}\n";
	&Gere_Index ;
    }
}
#|#######################################################
# Stolen from latex2html
sub get_date {
    local($format,$order) = @_;
    local(@lt) = localtime;
    local($d,$m,$y) = @lt[3,4,5];
    if ($format =~ /ISO/) {
	sprintf("%4d-%02d-%02d", 1900+$y, $m+1, $d);
    } elsif ($format) {
	if ($order) { eval "sprintf(".$format.",".$order.")"; }
	else { sprintf($format, $d, $m+1, 1900+$y); }
    } else { sprintf("%d/%d/%d", $m+1, $d, 1900+$y); }
}

sub address_data {
    local($user, $date, $_);
    local($format,$order) = @_;
    # Get author email address and current date.
    ($user = (getpwuid ($<))[6]) =~ s/,.*//;
    ($user, &get_date($format,$order));
}
#|#######################################################
sub Index_Index {
    local(@lt) = localtime;
    local($d,$m,$y) = @lt[3,4,5];
    @address_data = address_data('ISO');
    open(MAINFRAME,">$main::DIRE/index.html");
    print MAINFRAME '<HTML>
<HEAD>
<TITLE>Code '.$main::RepCodeSource.' de '.$main::USER.'.</TITLE>
</HEAD>
<BODY BGCOLOR=YELLOW LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1>Code '.$main::RepCodeSource.' de '.$main::USER.'.</H1>
Traduction du code '.$main::RepCodeSource.' en HTML par
<A Href="http://cessenat.free.fr/pub/ftagshtml.html">ftagshtml</A>
le '. scalar localtime() .'.
</BODY></HTML>';
#le '. $address_data[1].'.
#pour '. $address_data[0].'
#    foreach $t (getpwuid ($<)) { print "t=$t\n"; } ;
    close(MAINFRAME);
}
#|#######################################################
sub Index_Principal {
# index principal
    &Index_Index;
    open(MAINFRAME,">$main::DIRE/progindex.html");
    print MAINFRAME OpenMainFrame("index","progindex_c","Index des programmes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/progindex_c.html");
    print INDEX OpenIndex("Index des programmes de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort @main::programmes;
    $Main_Point_Href = "fileindex_c.html";
    $Main_Point_Name = "fileindex_c";
    while(@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	$Main_Point_Href = "$file"."_c.html#R_$Routine";
	$Main_Point_Name = "$file";
	print INDEX "<P><A NAME=$nom><LI></A>\n";
	print INDEX "Le programme ";
	print INDEX "<A HREF=\"${file}_c.html#R_$Routine\" TARGET=\"source\"".OnClick("$file","R_$Routine","index").">".$nom."</A>";
	print INDEX " est dclar dans <A HREF=\"${file}_c.html\" TARGET=\"source\"".OnClick("$file","","index").">".$file."</A> ";
	print INDEX "ligne $main::L_Declar{$nom}.<BR>\n";
	&Gere_Index ;
    }
    &Index_Ferme;
} ;

#|#######################################################
sub Index_Routines {
# index des routines
    open(MAINFRAME,">$main::DIRE/routindex.html");
    print MAINFRAME OpenMainFrame("index","routindex_c","Index des subroutines de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/routindex_c.html");
    print INDEX OpenIndex("Index des subroutines de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort @main::routines ;
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des subroutines (numro de ligne) : </H3><OL>\n";
	&FunSubIndex ;
    } else {
	print INDEX "<H3>Pas de subroutine fortran dans $main::RepCodeSource.</H3><OL>\n";
    }
    &Index_Ferme;
} ;

#|#######################################################
sub Index_Fonctions {
# index des fonctions
    open(MAINFRAME,">$main::DIRE/foncindex.html");
    print MAINFRAME OpenMainFrame("index","foncindex_c","Index des fonctions de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/foncindex_c.html");
    print INDEX OpenIndex("Index des fonctions de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");

    @liste=sort @main::functions ;
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des fonctions (numro de ligne) : </H3><OL>\n";
	&FunSubIndex ;
    } else {
	print INDEX "<H3>Pas de fonction dclare dans $main::RepCodeSource.</H3><OL>\n";
    }
    &Index_Ferme;
} ;
#|#######################################################
sub Gere_Index {
    $ligne=(main::Gere_Index_Appelants($nom,"source","index")) ;
    print INDEX "$ligne";
    $ligne=(main::Gere_Index_Appellees($nom,"source","index")) ;
    print INDEX "$ligne";
} ;
#|#######################################################
sub Index_Ferme {
# fermeture des fichiers HTML
print INDEX "</OL>\n";
print INDEX "</BODY></HTML>\n";
close(INDEX);
} ;
1;
